#pragma once

interface __declspec(uuid("95E19FD5-D011-4979-BBFB-26D9C358BDC0")) IDebug : public IUnknown
{
	virtual HRESULT STDMETHODCALLTYPE WriteLine(BSTR s) = 0;
	virtual HRESULT STDMETHODCALLTYPE WriteLineW(LPCWSTR s) = 0;
};

extern ATL::CComPtr<IDebug> g_Debug;
 
HRESULT DebugWriteLineF(LPCWSTR format, ...);

interface __declspec(uuid("36F21A71-822B-4CD5-9DC9-F1A68FE6AE04")) IDecoder : IUnknown
{
	virtual HRESULT STDMETHODCALLTYPE Init(/*[in]*/ IDebug* debug) = 0;
	virtual HRESULT STDMETHODCALLTYPE Decode(/*[in]*/ BYTE* source, /*[in]*/ int length, /*[out, ret]*/ SAFEARRAY** dest) = 0;
};
